package eta_business

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// EtaBusinessRemindRecord 客户提醒记录
type EtaBusinessRemindRecord struct {
	CompanyRemindRecordId int    `orm:"column(eta_business_remind_record_id);pk"`
	Type                  int    `description:"过期类型：1-1天；2-7天；3-15天；4-30天；5-60天"`
	SellerId              int    `description:"销售id"`
	SellerName            string `description:"销售名称"`
	EtaBusinessId         int    `description:"ETA商家ID"`
	BusinessName          string `description:"商家名称"`
	EndDate               string `description:"到期日期"`
	UniqueCode            string `description:"唯一code"`
	CreateTime            time.Time
}

func (m *EtaBusinessRemindRecord) Create() (err error) {
	o := orm.NewOrm()
	id, err := o.Insert(m)
	if err != nil {
		return
	}
	m.CompanyRemindRecordId = int(id)
	return
}

func (m *EtaBusinessRemindRecord) CreateMulti(items []*EtaBusinessRemindRecord) (err error) {
	if len(items) == 0 {
		return
	}
	o := orm.NewOrm()
	_, err = o.InsertMulti(len(items), items)
	return
}
